import { Action } from '@ngrx/store';
import { AuditMetadata } from '../models/audit-metadata';
import { Audit } from '../models/audit';

export enum DarsActionTypes {
  StartLoadingMetadata = '[DARS] Start Loading Metadata',
  AddAuditMetadata = '[DARS] Add Audit Metadata',
  StartLoadingAudit = '[DARS] Start Loading Audit',
  DoneLoadingAudit = '[DARS] Done Loading Audit',
  CloseAudit = '[DARS] Close Audit',
}

export class StartLoadingMetadata implements Action {
  public readonly type = DarsActionTypes.StartLoadingMetadata;
}

export class AddAuditMetadata implements Action {
  public readonly type = DarsActionTypes.AddAuditMetadata;
  constructor(public payload: { metadata: AuditMetadata[] }) {}
}

export class StartLoadingAudit implements Action {
  public readonly type = DarsActionTypes.StartLoadingAudit;
  constructor(public payload: { metadata: AuditMetadata }) {}
}

export class DoneLoadingAudit implements Action {
  public readonly type = DarsActionTypes.DoneLoadingAudit;
  constructor(public payload: { metadata: AuditMetadata; audit: Audit }) {}
}

export class CloseAudit implements Action {
  public readonly type = DarsActionTypes.CloseAudit;
}
